/*
DO NOT make any commercial use with this code.
Written by Tovi Levis.
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.DirectX;
using Microsoft.DirectX.DirectInput;


namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        TDxInput.Device Device = new TDxInput.Device();
        private TDxInput.Keyboard Keyboard;
        private TDxInput.Sensor Sensor;

        private const UInt32 MOUSEEVENTF_LEFTDOWN = 0x0002;
        private const UInt32 MOUSEEVENTF_LEFTUP = 0x0004;
        private const UInt32 MOUSEEVENTF_RIGHTDOWN = 0x0008;
        private const UInt32 MOUSEEVENTF_RIGHTUP = 0x0010;
        private const UInt32 MOUSEEVENTF_MIDDLEDOWN = 0x0020;
        private const UInt32 MOUSEEVENTF_MIDDLEUP = 0x0040;
        private const UInt32 MOUSEEVENTF_WHEEL = 0x0800;

        bool ExtraActive = true;
        bool DoWheelAction = false;
        bool MouseModeMiddleButton = false;
        bool MouseModeRightButton = false;
        bool MouseModeLeftButton = false;
       
        [DllImport("user32.dll")]
        private static extern void mouse_event(UInt32 dwFlags, UInt32 dx, UInt32 dy, int dwData, IntPtr dwExtraInfo);

        //private static extern void keybd_event(Byte bVk, Byte bScan, uint dwFlags, IntPtr dwExtraInfo);
        public Form1()
        {
            InitializeComponent();
            Device.Connect();
            Sensor = Device.Sensor;
            Sensor.SensorInput += new TDxInput._ISensorEvents_SensorInputEventHandler(Do_Sensor_Event);

            Keyboard = Device.Keyboard;
            Keyboard.KeyDown += new TDxInput._IKeyboardEvents_KeyDownEventHandler(Do_Keyboard_Down);
            Keyboard.KeyUp += new TDxInput._IKeyboardEvents_KeyUpEventHandler(Do_Keyboard_Up);
        }
        
        private void Do_Sensor_Event()
        {
            if (ExtraActive == true)
            {
                TDxInput.Vector3D Translation;
                TDxInput.AngleAxis Rotation;

                Translation = Sensor.Translation;
                Rotation = Sensor.Rotation;
                txtXPos.Text = Translation.X.ToString("f");
                txtYPos.Text = Translation.Y.ToString("f");
                txtZPos.Text = Translation.Z.ToString("f");

                txtXAxis.Text = Rotation.X.ToString("f");
                txtYAxis.Text = Rotation.Y.ToString("f");
                txtZAxis.Text = Rotation.Z.ToString("f");

                int iMX = Convert.ToInt32(Cursor.Position.X + Translation.X);
                int iMY = Convert.ToInt32(Cursor.Position.Y + Translation.Z);

                #region Wheel Action
                int Direction = 120;
                if (Rotation.X < -0.90)
                {
                    DoWheelAction = true;
                    Direction = 60;
                }
                if (Rotation.X > 0.90)
                {
                    DoWheelAction = true;
                    Direction = -60;
                }
                if (Rotation.X > -0.90 && Rotation.X < 0.90)
                {
                    DoWheelAction = false;
                }
                #endregion
                if (DoWheelAction == true && radNavMode1.Checked == true)
                {
                    if (chkM4.Checked == true)
                    {
                        UInt32 DoDelta = Convert.ToUInt32(10);
                        mouse_event(MOUSEEVENTF_WHEEL, 0, 0, Direction, new System.IntPtr());
                    }
                }
                else
                {
                    if (radNavMode1.Checked == true)
                    {
                        Cursor.Position = new Point(iMX, iMY);
                    }
                }


                double DetectUp = Convert.ToDouble(txtDoUp.Text);
                double DetectDown = Convert.ToDouble(txtDoDown.Text);
                double DetectForward = Convert.ToDouble(txtLowZPos.Text);
                double DetectBackward = Convert.ToDouble(txtUpZPos.Text);
                double DetectLeft = Convert.ToDouble(txtLowXPos.Text);
                double DetectRight = Convert.ToDouble(txtUpXPos.Text);


                if (Translation.Z < DetectForward)
                {
                    if (radNavMode2.Checked == true)
                    {
                        //SendKeys.SendWait(txtKeyActionUp.Text);
                        SendKeys.Send(txtKeyActionUp.Text);
                    }
                }
                if (Translation.Z > DetectBackward)
                {
                    if (radNavMode2.Checked == true)
                    {
                        SendKeys.Send(txtKeyActionDown.Text);
                    }
                }

                if (Translation.X > DetectRight)
                {
                    if (radNavMode2.Checked == true)
                    {
                        SendKeys.Send(txtKeyActionRight.Text);
                    }
                }
                if (Translation.X < DetectLeft)
                {
                    if (radNavMode2.Checked == true)
                    {
                        SendKeys.Send(txtKeyActionLeft.Text);
                    }
                }
                
                if (Translation.Y > DetectUp)
                {
                    lblNavigatorStatus.Text = "Up/Down Status: Up Action";
                    if (radNavMode2.Checked == true){
                        //SendKeys.Send(txtKeyActionUp.Text);
                    }
                }
                if (Translation.Y < DetectDown)
                {
                    lblNavigatorStatus.Text = "Up/Down Status: Down Action";
                    if (radNavMode1.Checked == true)
                    {
                        if (MouseModeMiddleButton == false && chkM3.Checked == true)
                        {
                            mouse_event(MOUSEEVENTF_MIDDLEDOWN, 0, 0, Direction, new System.IntPtr());
                            MouseModeMiddleButton = true;
                        }
                        if (MouseModeRightButton == false && chkM2.Checked == true)
                        {
                            mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, Direction, new System.IntPtr());
                            MouseModeRightButton = true;
                        }
                        if (MouseModeLeftButton == false && chkM1.Checked == true)
                        {
                            mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, Direction, new System.IntPtr());
                            MouseModeLeftButton = true;
                        }
                    }
                    else if (radNavMode2.Checked == true)
                    {
                        //SendKeys.Send(txtKeyActionDown.Text);
                    }
                }
                if (Translation.Y < DetectUp && Translation.Y > DetectDown)
                {
                    lblNavigatorStatus.Text = "Up/Down Status: Idle";
                    if (radNavMode1.Checked == true)
                    {
                        if (MouseModeMiddleButton == true && chkM3.Checked == true)
                        {
                            mouse_event(MOUSEEVENTF_MIDDLEUP, 0, 0, Direction, new System.IntPtr());
                            MouseModeMiddleButton = false;
                        }
                        if (MouseModeRightButton == true && chkM2.Checked == true)
                        {
                            mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, Direction, new System.IntPtr());
                            MouseModeRightButton = false;
                        }
                        if (MouseModeLeftButton == true && chkM1.Checked == true)
                        {
                            mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, Direction, new System.IntPtr());
                            MouseModeLeftButton = false;
                        }
                    }
                }
            }
        }

        private void Do_Keyboard_Down(int keyCode)
        {
            if (ExtraActive == true)
            {
                if (radNavMode1.Checked == true)
                {
                    if (keyCode == 1 && chkM5.Checked == true)
                    {
                        mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, new System.IntPtr());
                    }
                    else if (keyCode == 2 && chkM6.Checked == true)
                    {
                        mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, new System.IntPtr());
                    }
                }
            }
        }


        private void Do_Keyboard_Up(int keyCode)
        {
            if (ExtraActive == true)
            {
                if (radNavMode1.Checked == true)
                {
                    if (keyCode == 1 && chkM5.Checked == true)
                    {
                        mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, new System.IntPtr());
                    }
                    else if (keyCode == 2 && chkM6.Checked == true)
                    {
                        mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, new System.IntPtr());
                    }
                }
            }
        }
        
        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {
        }

        private void chkM1_CheckedChanged(object sender, EventArgs e)
        {
            if (chkM1.Checked == true)
            {
                chkM2.Checked = false;
                chkM3.Checked = false;
            }
        }

        private void chkM2_CheckedChanged(object sender, EventArgs e)
        {
            if (chkM2.Checked == true)
            {
                chkM1.Checked = false;
                chkM3.Checked = false;
            }

        }

        private void chkM3_CheckedChanged(object sender, EventArgs e)
        {
            if (chkM3.Checked == true)
            {
                chkM2.Checked = false;
                chkM1.Checked = false;
            }

        }

        private void radNavMode2_CheckedChanged(object sender, EventArgs e)
        {
            if (radNavMode2.Checked == true)
            {
                MouseActions.Enabled = false;
                KeyboardActions.Enabled = true;
            }else
            {
                MouseActions.Enabled = true;
                KeyboardActions.Enabled = false;
            }
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
            {
                this.Hide();
            }
        }

        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            this.Show();
            this.WindowState = FormWindowState.Normal;
        }

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {

        }
        private void enabledToolStripMenuItem_Clicked(object sender, EventArgs e)
        {
            if (enabledToolStripMenuItem.Checked == false)
            {
                enabledToolStripMenuItem.Checked = true;
                ExtraActive = true;
            }
            else
            {
                enabledToolStripMenuItem.Checked = false;
                ExtraActive = false;
            }
        }
        private void exitToolStripMenuItem_Clicked(object sender, EventArgs e)
        {
            Application.Exit();
        }
        
        private void showToolStripMenuItem_Clicked(object sender, EventArgs e)
        {
            this.Show();
            this.WindowState = FormWindowState.Normal;
        }
    }
}